<DOCTYPEY! html>

<html>
<head>
    <link rel="stylesheet" href="style.css">
    <script src="node_modules/sercets.js/secrets.min.js"></script>
    <script src="pbkdf2.js"></script>
    <script src="aes-gcm.js"></script>
    <script src="rsa-oaep.js"></script>
    <script type="text/javascript">
        var saltBuffer1 = crypto.getRandomValues(new Uint8Array(16));
        var saltBuffer2 = crypto.getRandomValues(new Uint8Array(16));

        var iv = crypto.getRandomValues(new Uint8Array(12));

        var AUTHKEY;
        var MASTERKEY;

        var SHARDS = [];
        var ENCRYPTEDSHARDS = [];
        var DECRYPTEDSHARDS = [];
        var publicKeys = [];
        var privateKeys = [];

        function asciiToArrayBuffer(str) {
            var chars = [];
            for (var i = 0; i < str.length; ++i)
                chars.push(str.charCodeAt(i));
            return new Uint8Array(chars);
        }

        function arrayBufferToAscii(buffer) { 
            return String.fromCharCode.apply(null, new Uint8Array(buffer)); 
        }

        function arrayBufferToBase64(buffer) {
            let binary = '';
            let bytes = new Uint8Array(buffer);
            let len = bytes.byteLength;
            for (let i = 0; i < len; i++) {
                binary += String.fromCharCode(bytes[i]);
            }
            return window.btoa(binary);
        }

        function base64ToArrayBuffer(base64) {
            var binary_string =  window.atob(base64);
            var len = binary_string.length;
            var bytes = new Uint8Array( len );
            for (var i = 0; i < len; i++) {
                bytes[i] = binary_string.charCodeAt(i);
            }
            return bytes.buffer;
        }
    
        function arrayBufferToHexString(buffer) {
            if (!buffer)
                return null;

            buffer = new Uint8Array(buffer);
            var hexString = [];

            for (var i = 0; i < buffer.length; ++i) {
                var byteString = buffer[i].toString(16);
                if (byteString.length < 2)
                    byteString = "0" + byteString;
                hexString.push(byteString);
            }

            return hexString.join("");
        }

        function hexStringToArrayBuffer(hexString) {
            if (hexString.length % 2 != 0)
                throw "Invalid hexString";
            var arrayBuffer = new Uint8Array(hexString.length / 2);

            for (var i = 0; i < hexString.length; i += 2) {
                var byteValue = parseInt(hexString.substr(i, 2), 16);
                if (byteValue == NaN)
                    throw "Invalid hexString";
                arrayBuffer[i/2] = byteValue;
            }

            return arrayBuffer;
        }

        async function encrypt() {
            var plaintext = document.getElementById("plaintext").value;
            let ciphertext = await AES_GCM_encrypt(MASTERKEY, plaintext);
            document.getElementById("ciphertext").value = ciphertext;     
            console.log("Chiffrat: " + ciphertext);
        }

        async function decrypt() {
            var ciphertext = document.getElementById("ciphertext").value;    
            let plaintext = await AES_GCM_decrypt(MASTERKEY, ciphertext);  
            document.getElementById("result").value = plaintext;       
            console.log("Klartext: " + plaintext);
        }
    
        async function registerUser() {
            var password = document.getElementById("registerPW").value;

            var masterKey = await deriveMasterKey(password);
            var exportMasterKey = await window.crypto.subtle.exportKey("raw", masterKey);

            var authHash = await deriveAuthHash(arrayBufferToHexString(exportMasterKey));
            var exportAuthHash = await window.crypto.subtle.exportKey("raw", authHash);
            document.getElementById("registerAH").value = arrayBufferToHexString(exportAuthHash);

            var authKey = await deriveAuthKey(arrayBufferToHexString(exportAuthHash));
            var exportAuthKey = await window.crypto.subtle.exportKey("raw", authKey);
            document.getElementById("registerAK").value = arrayBufferToHexString(exportAuthKey);

            AUTHKEY = arrayBufferToHexString(exportAuthKey);
        }
   
        async function loginUser() {
            var password = document.getElementById("loginPW").value;

            var masterKey = await deriveMasterKey(password);
            var exportMasterKey = await window.crypto.subtle.exportKey("raw", masterKey);
            document.getElementById("masterkey").value = arrayBufferToHexString(exportMasterKey);

            var authHash = await deriveAuthHash(arrayBufferToHexString(exportMasterKey));
            var exportAuthHash = await window.crypto.subtle.exportKey("raw", authHash);
            document.getElementById("loginAH").value = arrayBufferToHexString(exportAuthHash);

            var authKey = await deriveAuthKey(arrayBufferToHexString(exportAuthHash));
            var exportAuthKey = await window.crypto.subtle.exportKey("raw", authKey);
            document.getElementById("loginAK").value = arrayBufferToHexString(exportAuthKey);

            await authenticate(AUTHKEY, arrayBufferToHexString(exportAuthKey));

            MASTERKEY = masterKey;
        }

        async function authenticate(registerAK, loginAK) {
            if (registerAK === loginAK) {
                document.getElementById("authStatus").value = "Login erfolgreich";
            } else {
                document.getElementById("authStatus").value = "Login fehlgeschlagen";
            }
        }

        async function generateKeyPair() {
            var pairCount = document.getElementById("pieces-k").value;
            for (let index = 0; index < pairCount; index++) {
                await window.crypto.subtle.generateKey( 
                    {
                    name: "RSA-OAEP",
                    modulusLength: 4096,
                    publicExponent: new Uint8Array([1, 0, 1]),
                    hash: "SHA-256",
                    },
                    true,
                    ["encrypt", "decrypt"]
                ).then((keyPair) => {
                    publicKeys.push(keyPair.publicKey);
                    privateKeys.push(keyPair.privateKey);
                });     
            }
            console.log(publicKeys);
            console.log(privateKeys);
        }

        function generateShards() {

            secrets.init();
            var k = parseInt(document.getElementById("pieces-k").value);
            var n = parseInt(document.getElementById("pieces-n").value);

            var key = document.getElementById("sharedSecret").value;
            key = secrets.str2hex(key);
           
            SHARDS = secrets.share(key, k, n);

            console.log(SHARDS);
            console.log(secrets.hex2str(key));

            SHARDS.forEach(function(element) {
                document.getElementById("generated-pieces").value =  document.getElementById("generated-pieces").value + element + "\n\n";
            });
        }

        async function encryptShards() {
            for (let index = 0; index < SHARDS.length; index++) {
                let encrypted = await RSA_OAEP_encrypt(publicKeys[index], SHARDS[index]);
                document.getElementById("encrypted-pieces").value =  document.getElementById("encrypted-pieces").value + encrypted + "$$KeyNr.:$$" + index + "\n\n";       
            };
        }

        function recoverShards() {
            var k = parseInt(document.getElementById("pieces-k").value);
            var n = parseInt(document.getElementById("pieces-n").value);

            var encryptedShards = document.getElementById("recovery-pieces").value.split('\n');
            encryptedShards = encryptedShards.filter(Boolean);
            encryptedShards.forEach(function(element) {
                element = element.replace("$$KeyNr.:$$", " ");
                ENCRYPTEDSHARDS.push(element.split(" "));
            })

            if(ENCRYPTEDSHARDS.length < n) {
                alert("More pieces are needed for recovery! Must have at least " + n);
            }
    
            console.log(ENCRYPTEDSHARDS);

            //var comb = secrets.combine(pieces);
            //console.log(secrets.hex2str(comb));
        }

        async function decryptShards() {
            for (let index = 0; index < ENCRYPTEDSHARDS.length; index++) {
                var privateKeyIndex = ENCRYPTEDSHARDS[index][1]
                let decrypted = await RSA_OAEP_decrypt(privateKeys[privateKeyIndex], ENCRYPTEDSHARDS[index][0])
                console.log(decrypted);
                document.getElementById("decrypted-pieces").value =  document.getElementById("decrypted-pieces").value + decrypted + "\n\n";
                DECRYPTEDSHARDS.push(decrypted);
            };
        }

        function recoverSecret() {
            var secret = secrets.combine(DECRYPTEDSHARDS);
            document.getElementById("secret").value = secrets.hex2str(secret);
            console.log(secrets.hex2str(secret));
        }
            
   </script>
</head>
<body>
    <div>
        <h1>Register</h1>
        <div>
            <label><b>Provide Password:</b></label><br />
            <input type="password" id="registerPW" /><br />
            <button type="button" onclick="registerUser()">Register User</button><br />
            <label>Auth-Hash (Hex):</label><br />
            <input readonly="true" size="50" type="text" id="registerAH" /><br />
            <label>Auth-Key (Hex): </label><br />
            <input readonly="true" size="50" type="text" id="registerAK" /><br />
            <p>Beim Registrieren wird die Implementierung des PBKDF2 verwendet, um aus dem Passwort den
                Auth-Hash zu erzeugen. Von diesem wird dann der Auth-Key abgeleitet. Dieser Auth-Key wird 
                in einer Variable gespeichert, um den Nutzer beim Login authentifizieren zu können.</p>
        </div>
        <h1>Login</h1>
        <div>
            <label><b>Provide Password:</b></label><br />
            <input type="password" id="loginPW" /><br />
            <button type="button" onclick="loginUser()">Login User</button><br />
            <label>Master-Key (Hex):</label><br /> 
            <input readonly="true" size="50" type="text" id="masterkey" /><br />
            <label>Auth-Hash (Hex):</label><br /> 
            <input readonly="true" size="50" type="text" id="loginAH" /><br />
            <label>Auth-Key (Hex):</label><br /> 
            <input readonly="true" size="50" type="text" id="loginAK" /><br />
            <p>Hier soll die Authentifizierung bei einem Login simuliert werden. Beim Login wird erneut 
                mit der PBKDF2 ein Auth-Key erzeugt und mit dem bei der Registrierung erstellten Schlüssel 
                verglichen. Außerdem wird der Master-Key angelegt, der bei der Verschlüsselung verwendet 
                wird.</p>
            <label>Status:</label><br />
            <input readonly="true" size="50" type="text" id="authStatus" /><br />
            <p>Wurde beim Login und der Registrierung das selbe Passwort angegeben, ist der Login 
                erfolgreich</p>
            
        </div>
        <h1>Encryption</h1>
        <div>
            <label><b>Provide Plain Text:</b></label><br /> 
            <input type="text" size="50" id="plaintext"><br />
            <button type="button" onclick="encrypt()">Encrypt with AES-GCM</button><br />
            <label>Cipher Text (Hex):</label><br /> 
            <!--<input readonly="true" type="text" size="50" id="ciphertext"><br /> -->
            <textarea class="ct" readonly="true" type="text" size="50" id="ciphertext" rows="11"></textarea><br />
            <button type="button" onclick="decrypt()">Decrypt with AES-GCM</button><br />
            <label>Result:</label><br /> 
            <input readonly="true" type="text" size="50" id="result"><br />
            <p>Der eingegebene Klartext wird mit dem beim Login abgeleiteten Master-Key unter Verwendung 
                des AES256 im GCM-Modus verschlüsselt und anschließend wieder entschlüsselt.</p>
        </div>
        <h1>Secret Sharing</h1>
        <div>
            <label><b>Provide Secret:</b></label><br /> 
            <input type="text" id="sharedSecret" /><br />   
            <label><b>Number of Shares (k):</b></label><br /> 
            <input type="text" size="50" id="pieces-k"><br />
            <label><b>Required Number of Shares for Reconstruction (n):</b></label><br />
            <input type="text" size="50" id="pieces-n"><br />
            <p>Beim Secret Sharing soll ein Geheimnis, im Konzept der Master-Key des Nutzers in mehrere 
                Shares aufgeteilt werden. Es kann festgelegt werden, wie viele k Teile erzeugt werden 
                sollen. Mit dem Parameter n wird bestimmt, dass mindestens n davon benötigt werden, um 
                das Geheimnis wiederherzustellen.</p>
            <button type="button" onclick="generateKeyPair()">Generate k Key Pairs</button><br />
            <p>Es werden k Schlüsselpaare generiert, um die einzelnen Shares später mit dem RSA-OAEP 
                verschlüsseln und entschlüsseln zu können. Die Schlüsselpaare werden dazu in zwei Arrays, 
                einer für die Public Keys und einer für die Private Keys, gespeichert.</p>
            <button type="button" onclick="generateShards()">Generate Shares</button><button type="button" onclick="encryptShards()">Encrypt Shares with RSA-OAEP</button><br />
            <textarea class="shards" id="generated-pieces" rows="11"></textarea><textarea class="encryptedShards" id="encrypted-pieces" rows="11"></textarea><br />
            <p>In dem linken Textfeld befinden sich die generierten k Shares, die vom Secret abgeleitet 
                wurden. Rechts sind diese verschlüsselt vorzufinden.</p>    
            <button type="button" onclick="recoverShards()">Recover Shares</button><button type="button" onclick="decryptShards()">Decrypt Shares with RSA-OAEP</button><br />
            <p>Um die Shares wieder entschlüsseln zu können, müssen mindestens n der verschlüsselten 
                Shares in das linke Textfeld eingefügt werden. Nach der Entschlüsselung befinden sich
                im rechten Textfeld die Shares als Klartext.</p>
            <textarea class="encryptedShards" id="recovery-pieces" rows="11"></textarea><textarea class="shards" id="decrypted-pieces" rows="11"></textarea><br />
            <button type="button" onclick="recoverSecret()" >Recover Secret</button><br />
            <p>Wurden mindestens n Shares eingegeben, kann das Geheimnis erfolgreich wiederhergestellt werden.</p>
            <label>Secret: </label> <input readonly="true" type="text" size="50" id="secret"><br />
        </div>
    </div>

</body>
</html>
